Makefile 11.1 KB
Newer Older
L
Linus Torvalds 已提交
1 2 3 4
# ===========================================================================
# Kernel configuration targets
# These targets are used from top-level makefile

5
PHONY += oldconfig xconfig gconfig menuconfig config silentoldconfig update-po-config \
6
	localmodconfig localyesconfig
L
Linus Torvalds 已提交
7

A
Al Viro 已提交
8 9 10
ifdef KBUILD_KCONFIG
Kconfig := $(KBUILD_KCONFIG)
else
11
Kconfig := Kconfig
A
Al Viro 已提交
12
endif
13

14 15 16
# We need this, in case the user has it in its environment
unexport CONFIG_

L
Linus Torvalds 已提交
17
xconfig: $(obj)/qconf
18
	$< $(Kconfig)
L
Linus Torvalds 已提交
19 20

gconfig: $(obj)/gconf
21
	$< $(Kconfig)
L
Linus Torvalds 已提交
22 23

menuconfig: $(obj)/mconf
24
	$< $(Kconfig)
L
Linus Torvalds 已提交
25 26

config: $(obj)/conf
S
Sam Ravnborg 已提交
27
	$< --oldaskconfig $(Kconfig)
L
Linus Torvalds 已提交
28

29 30 31
nconfig: $(obj)/nconf
	$< $(Kconfig)

L
Linus Torvalds 已提交
32
oldconfig: $(obj)/conf
S
Sam Ravnborg 已提交
33
	$< --$@ $(Kconfig)
L
Linus Torvalds 已提交
34 35

silentoldconfig: $(obj)/conf
36
	$(Q)mkdir -p include/config include/generated
S
Sam Ravnborg 已提交
37
	$< --$@ $(Kconfig)
L
Linus Torvalds 已提交
38

39
localyesconfig localmodconfig: $(obj)/streamline_config.pl $(obj)/conf
40
	$(Q)mkdir -p include/config include/generated
41
	$(Q)perl $< --$@ $(srctree) $(Kconfig) > .tmp.config
42
	$(Q)if [ -f .config ]; then 					\
S
Sam Ravnborg 已提交
43 44 45 46 47 48 49 50
			cmp -s .tmp.config .config ||			\
			(mv -f .config .config.old.1;			\
			 mv -f .tmp.config .config;			\
			 $(obj)/conf --silentoldconfig $(Kconfig);	\
			 mv -f .config.old.1 .config.old)		\
	else								\
			mv -f .tmp.config .config;			\
			$(obj)/conf --silentoldconfig $(Kconfig);	\
51
	fi
52 53
	$(Q)rm -f .tmp.config

E
EGRY Gabor 已提交
54
# Create new linux.pot file
S
Sam Ravnborg 已提交
55
# Adjust charset to UTF-8 in .po file to accept UTF-8 in Kconfig files
56
update-po-config: $(obj)/kxgettext $(obj)/gconf.glade.h
P
Peter Foley 已提交
57
	$(Q)echo "  GEN     config.pot"
58 59 60 61 62
	$(Q)xgettext --default-domain=linux                         \
	    --add-comments --keyword=_ --keyword=N_                 \
	    --from-code=UTF-8                                       \
	    --files-from=$(srctree)/scripts/kconfig/POTFILES.in     \
	    --directory=$(srctree) --directory=$(objtree)           \
S
Sam Ravnborg 已提交
63 64
	    --output $(obj)/config.pot
	$(Q)sed -i s/CHARSET/UTF-8/ $(obj)/config.pot
65 66
	$(Q)(for i in `ls $(srctree)/arch/*/Kconfig      \
	    $(srctree)/arch/*/um/Kconfig`;               \
E
EGRY Gabor 已提交
67
	    do                                           \
P
Peter Foley 已提交
68
		echo "  GEN     $$i";                    \
69
		$(obj)/kxgettext $$i                     \
E
EGRY Gabor 已提交
70 71
		     >> $(obj)/config.pot;               \
	    done )
P
Peter Foley 已提交
72
	$(Q)echo "  GEN     linux.pot"
E
EGRY Gabor 已提交
73
	$(Q)msguniq --sort-by-file --to-code=UTF-8 $(obj)/config.pot \
S
Sam Ravnborg 已提交
74 75
	    --output $(obj)/linux.pot
	$(Q)rm -f $(obj)/config.pot
76

S
Sam Ravnborg 已提交
77
PHONY += allnoconfig allyesconfig allmodconfig alldefconfig randconfig
L
Linus Torvalds 已提交
78

S
Sam Ravnborg 已提交
79
allnoconfig allyesconfig allmodconfig alldefconfig randconfig: $(obj)/conf
S
Sam Ravnborg 已提交
80
	$< --$@ $(Kconfig)
L
Linus Torvalds 已提交
81

82
PHONY += listnewconfig olddefconfig oldnoconfig savedefconfig defconfig
L
Linus Torvalds 已提交
83

84
listnewconfig olddefconfig: $(obj)/conf
S
Sam Ravnborg 已提交
85
	$< --$@ $(Kconfig)
L
Linus Torvalds 已提交
86

87 88 89 90 91 92
# oldnoconfig is an alias of olddefconfig, because people already are dependent
# on its behavior(sets new symbols to their default value but not 'n') with the
# counter-intuitive name.
oldnoconfig: $(obj)/conf
	$< --olddefconfig $(Kconfig)

S
Sam Ravnborg 已提交
93 94 95
savedefconfig: $(obj)/conf
	$< --$@=defconfig $(Kconfig)

L
Linus Torvalds 已提交
96 97
defconfig: $(obj)/conf
ifeq ($(KBUILD_DEFCONFIG),)
S
Sam Ravnborg 已提交
98
	$< --defconfig $(Kconfig)
L
Linus Torvalds 已提交
99
else
100
	@echo "*** Default configuration is based on '$(KBUILD_DEFCONFIG)'"
S
Sam Ravnborg 已提交
101
	$(Q)$< --defconfig=arch/$(SRCARCH)/configs/$(KBUILD_DEFCONFIG) $(Kconfig)
L
Linus Torvalds 已提交
102 103 104
endif

%_defconfig: $(obj)/conf
S
Sam Ravnborg 已提交
105
	$(Q)$< --defconfig=arch/$(SRCARCH)/configs/$@ $(Kconfig)
L
Linus Torvalds 已提交
106 107 108 109

# Help text used by make help
help:
	@echo  '  config	  - Update current config utilising a line-oriented program'
110
	@echo  '  nconfig         - Update current config utilising a ncurses menu based program'
L
Linus Torvalds 已提交
111 112 113 114
	@echo  '  menuconfig	  - Update current config utilising a menu based program'
	@echo  '  xconfig	  - Update current config utilising a QT based front-end'
	@echo  '  gconfig	  - Update current config utilising a GTK based front-end'
	@echo  '  oldconfig	  - Update current config utilising a provided .config as base'
115
	@echo  '  localmodconfig  - Update current config disabling modules not loaded'
116
	@echo  '  localyesconfig  - Update current config converting local mods to core'
117
	@echo  '  silentoldconfig - Same as oldconfig, but quietly, additionally update deps'
S
Sam Ravnborg 已提交
118
	@echo  '  defconfig	  - New config with default from ARCH supplied defconfig'
S
Sam Ravnborg 已提交
119
	@echo  '  savedefconfig   - Save current config as ./defconfig (minimal config)'
120
	@echo  '  allnoconfig	  - New config where all options are answered with no'
S
Sam Ravnborg 已提交
121 122 123 124
	@echo  '  allyesconfig	  - New config where all options are accepted with yes'
	@echo  '  allmodconfig	  - New config selecting modules when possible'
	@echo  '  alldefconfig    - New config with all symbols set to default'
	@echo  '  randconfig	  - New config with random answer to all options'
125
	@echo  '  listnewconfig   - List new options'
126
	@echo  '  olddefconfig	  - Same as silentoldconfig but sets new symbols to their default value'
L
Linus Torvalds 已提交
127

128 129 130
# lxdialog stuff
check-lxdialog  := $(srctree)/$(src)/lxdialog/check-lxdialog.sh

131
# Use recursively expanded variables so we do not call gcc unless
132
# we really need to do so. (Do not call gcc as part of make mrproper)
133 134
HOST_EXTRACFLAGS += $(shell $(CONFIG_SHELL) $(check-lxdialog) -ccflags) \
                    -DLOCALE
135

L
Linus Torvalds 已提交
136 137 138
# ===========================================================================
# Shared Makefile for the various kconfig executables:
# conf:	  Used for defconfig, oldconfig and related targets
139 140
# nconf:  Used for the nconfig target.
#         Utilizes ncurses
141
# mconf:  Used for the menuconfig target
L
Linus Torvalds 已提交
142 143 144 145 146 147 148
#         Utilizes the lxdialog package
# qconf:  Used for the xconfig target
#         Based on QT which needs to be installed to compile it
# gconf:  Used for the gconfig target
#         Based on GTK which needs to be installed to compile it
# object files used by all kconfig flavours

149 150 151
lxdialog := lxdialog/checklist.o lxdialog/util.o lxdialog/inputbox.o
lxdialog += lxdialog/textbox.o lxdialog/yesno.o lxdialog/menubox.o

L
Linus Torvalds 已提交
152
conf-objs	:= conf.o  zconf.tab.o
153 154
mconf-objs     := mconf.o zconf.tab.o $(lxdialog)
nconf-objs     := nconf.o zconf.tab.o nconf.gui.o
155
kxgettext-objs	:= kxgettext.o zconf.tab.o
156
qconf-cxxobjs	:= qconf.o
157 158
qconf-objs	:= zconf.tab.o
gconf-objs	:= gconf.o zconf.tab.o
L
Linus Torvalds 已提交
159

160
hostprogs-y := conf
161

162 163 164 165
ifeq ($(MAKECMDGOALS),nconfig)
	hostprogs-y += nconf
endif

166 167 168 169
ifeq ($(MAKECMDGOALS),menuconfig)
	hostprogs-y += mconf
endif

170 171 172 173
ifeq ($(MAKECMDGOALS),update-po-config)
	hostprogs-y += kxgettext
endif

L
Linus Torvalds 已提交
174 175 176 177 178 179 180 181 182
ifeq ($(MAKECMDGOALS),xconfig)
	qconf-target := 1
endif
ifeq ($(MAKECMDGOALS),gconfig)
	gconf-target := 1
endif


ifeq ($(qconf-target),1)
183
	hostprogs-y += qconf
L
Linus Torvalds 已提交
184 185 186
endif

ifeq ($(gconf-target),1)
187
	hostprogs-y += gconf
L
Linus Torvalds 已提交
188 189
endif

190
clean-files	:= qconf.moc .tmp_qtcheck .tmp_gtkcheck
A
Arnaud Lacombe 已提交
191
clean-files	+= zconf.tab.c zconf.lex.c zconf.hash.c gconf.glade.h
192
clean-files     += mconf qconf gconf nconf
E
EGRY Gabor 已提交
193
clean-files     += config.pot linux.pot
L
Linus Torvalds 已提交
194

195 196 197 198
# Check that we have the required ncurses stuff installed for lxdialog (menuconfig)
PHONY += $(obj)/dochecklxdialog
$(addprefix $(obj)/,$(lxdialog)): $(obj)/dochecklxdialog
$(obj)/dochecklxdialog:
199
	$(Q)$(CONFIG_SHELL) $(check-lxdialog) -check $(HOSTCC) $(HOST_EXTRACFLAGS) $(HOSTLOADLIBES_mconf)
200 201 202

always := dochecklxdialog

203 204
# Add environment specific flags
HOST_EXTRACFLAGS += $(shell $(CONFIG_SHELL) $(srctree)/$(src)/check.sh $(HOSTCC) $(HOSTCFLAGS))
205

L
Linus Torvalds 已提交
206
# generated files seem to need this to find local include files
A
Arnaud Lacombe 已提交
207
HOSTCFLAGS_zconf.lex.o	:= -I$(src)
L
Linus Torvalds 已提交
208 209
HOSTCFLAGS_zconf.tab.o	:= -I$(src)

210 211 212
LEX_PREFIX_zconf	:= zconf
YACC_PREFIX_zconf	:= zconf

213 214
HOSTLOADLIBES_qconf	= $(KC_QT_LIBS)
HOSTCXXFLAGS_qconf.o	= $(KC_QT_CFLAGS)
L
Linus Torvalds 已提交
215

216
HOSTLOADLIBES_gconf	= `pkg-config --libs gtk+-2.0 gmodule-2.0 libglade-2.0`
217
HOSTCFLAGS_gconf.o	= `pkg-config --cflags gtk+-2.0 gmodule-2.0 libglade-2.0` \
218
                          -Wno-missing-prototypes
L
Linus Torvalds 已提交
219

220 221
HOSTLOADLIBES_mconf   = $(shell $(CONFIG_SHELL) $(check-lxdialog) -ldflags $(HOSTCC))

222 223 224
HOSTLOADLIBES_nconf	= $(shell \
				pkg-config --libs menu panel ncurses 2>/dev/null \
				|| echo "-lmenu -lpanel -lncurses"  )
L
Linus Torvalds 已提交
225 226 227
$(obj)/qconf.o: $(obj)/.tmp_qtcheck

ifeq ($(qconf-target),1)
228
$(obj)/.tmp_qtcheck: $(src)/Makefile
L
Linus Torvalds 已提交
229 230 231 232
-include $(obj)/.tmp_qtcheck

# QT needs some extra effort...
$(obj)/.tmp_qtcheck:
233
	@set -e; echo "  CHECK   qt"; dir=""; pkg=""; \
A
Alexander Stein 已提交
234 235 236 237 238 239 240 241 242 243 244 245 246 247
	if ! pkg-config --exists QtCore 2> /dev/null; then \
	    echo "* Unable to find the QT4 tool qmake. Trying to use QT3"; \
	    pkg-config --exists qt 2> /dev/null && pkg=qt; \
	    pkg-config --exists qt-mt 2> /dev/null && pkg=qt-mt; \
	    if [ -n "$$pkg" ]; then \
	      cflags="\$$(shell pkg-config $$pkg --cflags)"; \
	      libs="\$$(shell pkg-config $$pkg --libs)"; \
	      moc="\$$(shell pkg-config $$pkg --variable=prefix)/bin/moc"; \
	      dir="$$(pkg-config $$pkg --variable=prefix)"; \
	    else \
	      for d in $$QTDIR /usr/share/qt* /usr/lib/qt*; do \
	        if [ -f $$d/include/qconfig.h ]; then dir=$$d; break; fi; \
	      done; \
	      if [ -z "$$dir" ]; then \
248 249 250 251 252 253
	        echo >&2 "*"; \
	        echo >&2 "* Unable to find any QT installation. Please make sure that"; \
	        echo >&2 "* the QT4 or QT3 development package is correctly installed and"; \
	        echo >&2 "* either qmake can be found or install pkg-config or set"; \
	        echo >&2 "* the QTDIR environment variable to the correct location."; \
	        echo >&2 "*"; \
A
Alexander Stein 已提交
254 255 256 257 258 259 260 261 262 263 264 265 266 267 268 269 270
	        false; \
	      fi; \
	      libpath=$$dir/lib; lib=qt; osdir=""; \
	      $(HOSTCXX) -print-multi-os-directory > /dev/null 2>&1 && \
	        osdir=x$$($(HOSTCXX) -print-multi-os-directory); \
	      test -d $$libpath/$$osdir && libpath=$$libpath/$$osdir; \
	      test -f $$libpath/libqt-mt.so && lib=qt-mt; \
	      cflags="-I$$dir/include"; \
	      libs="-L$$libpath -Wl,-rpath,$$libpath -l$$lib"; \
	      moc="$$dir/bin/moc"; \
	    fi; \
	    if [ ! -x $$dir/bin/moc -a -x /usr/bin/moc ]; then \
	      echo "*"; \
	      echo "* Unable to find $$dir/bin/moc, using /usr/bin/moc instead."; \
	      echo "*"; \
	      moc="/usr/bin/moc"; \
	    fi; \
271
	else \
272 273
	  cflags="\$$(shell pkg-config QtCore QtGui Qt3Support --cflags)"; \
	  libs="\$$(shell pkg-config QtCore QtGui Qt3Support --libs)"; \
274 275
	  moc="\$$(shell pkg-config QtCore --variable=moc_location)"; \
	  [ -n "$$moc" ] || moc="\$$(shell pkg-config QtCore --variable=prefix)/bin/moc"; \
276 277 278 279
	fi; \
	echo "KC_QT_CFLAGS=$$cflags" > $@; \
	echo "KC_QT_LIBS=$$libs" >> $@; \
	echo "KC_QT_MOC=$$moc" >> $@
L
Linus Torvalds 已提交
280 281 282 283 284 285 286 287 288
endif

$(obj)/gconf.o: $(obj)/.tmp_gtkcheck

ifeq ($(gconf-target),1)
-include $(obj)/.tmp_gtkcheck

# GTK needs some extra effort, too...
$(obj)/.tmp_gtkcheck:
289 290
	@if `pkg-config --exists gtk+-2.0 gmodule-2.0 libglade-2.0`; then		\
		if `pkg-config --atleast-version=2.0.0 gtk+-2.0`; then			\
L
Linus Torvalds 已提交
291 292
			touch $@;								\
		else									\
293 294 295
			echo >&2 "*"; 							\
			echo >&2 "* GTK+ is present but version >= 2.0.0 is required.";	\
			echo >&2 "*";							\
L
Linus Torvalds 已提交
296 297 298
			false;								\
		fi									\
	else										\
299 300 301 302 303
		echo >&2 "*"; 								\
		echo >&2 "* Unable to find the GTK+ installation. Please make sure that"; 	\
		echo >&2 "* the GTK+ 2.0 development package is correctly installed..."; 	\
		echo >&2 "* You need gtk+-2.0, glib-2.0 and libglade-2.0."; 		\
		echo >&2 "*"; 								\
L
Linus Torvalds 已提交
304 305 306 307
		false;									\
	fi
endif

A
Arnaud Lacombe 已提交
308
$(obj)/zconf.tab.o: $(obj)/zconf.lex.c $(obj)/zconf.hash.c
L
Linus Torvalds 已提交
309

310
$(obj)/qconf.o: $(obj)/qconf.moc
L
Linus Torvalds 已提交
311

312 313 314 315 316
quiet_cmd_moc = MOC     $@
      cmd_moc = $(KC_QT_MOC) -i $< -o $@

$(obj)/%.moc: $(src)/%.h $(obj)/.tmp_qtcheck
	$(call cmd,moc)
L
Linus Torvalds 已提交
317

318 319
# Extract gconf menu items for I18N support
$(obj)/gconf.glade.h: $(obj)/gconf.glade
P
Peter Foley 已提交
320
	$(Q)intltool-extract --type=gettext/glade --srcdir=$(srctree) \
321
	$(obj)/gconf.glade